!  Thu Oct 22 15:15:59 CEST 2015
!  Written by Pedro Ojeda
      PROGRAM HELLO
      USE OMP_LIB
      IMPLICIT NONE
      INTEGER :: I
      INTEGER, PARAMETER :: NLIN=1E9
      INTEGER, PARAMETER :: CHUNK=100
      INTEGER :: RATE,T1,T2
      REAL*8  :: X,PI,PI_TEMP


      CALL SYSTEM_CLOCK(COUNT_RATE=RATE)
!Compute PI in serial mode
      CALL SYSTEM_CLOCK(T1)
      PI=0.0D0
      X=0.0D0
      DO I=1,NLIN
      X=I*1.0D0/(1.0D0*NLIN)
      PI=PI+4.0D0/(1.0D0+X*X)
      ENDDO
      CALL SYSTEM_CLOCK(T2)

      WRITE(*,*) 'PI',PI/(1.0D0*NLIN),'TIME',REAL(T2-T1)/REAL(RATE)


!Compute PI using OpenMP mode
      CALL SYSTEM_CLOCK(T1)
      PI=0.0D0
      X=0.0D0
      pi_temp=10.0
!$OMP  PARALLEL DO Private(x,i) reduction(+:PI_temp)
      DO I=1,NLIN
      X=I*1.0D0/(1.0D0*NLIN)
      PI_TEMP=PI_TEMP+4.0D0/(1.0D0+X*X)
      ENDDO
!$OMP END PARALLEL DO
      PI =PI_TEMP
      CALL SYSTEM_CLOCK(T2)

      WRITE(*,*) 'PI',PI/(1.0D0*NLIN),'TIME',REAL(T2-T1)/REAL(RATE)


      END
